#include "TI-85.H"

.org 0
.db "ZShess v1.0e", 0

;-----------------------------------------------------
; vars
;-----------------------------------------------------
Plr = TEXT_MEM      ; player (0 : white ; 1 : black) 
Sel = TEXT_MEM + 1  ; selection "flag"
PX  = TEXT_MEM + 2  ; cursor position : _ col
PY  = TEXT_MEM + 3  ;                   _ row
PxO = TEXT_MEM + 4  ; older position
PyO = TEXT_MEM + 5
MOk = TEXT_MEM + 6  ; to know if the movement is correct
ChM = TEXT_MEM + 7  ; chessboard : 64 bytes
Rk  = TEXT_MEM + 71 ; data for castle : 4 bytes
Pic = TEXT_MEM + 75 ; piece number
Ptp = TEXT_MEM + 76 ; reduced piece number(w/o color)

;----------------------------------------------------- 
; Beginning of the code
;-----------------------------------------------------

 ld a, (ZS_BITS)
 set 0, a
 ld (ZS_BITS), a    ; because you modify data when saving
 res 1, (IY+0D) 
 res 3, (IY+05)
 
 ROM_CALL(CLEARLCD)
 ld hl, 1
 ld ($8003), hl
 ld hl, MyScr
 ld de, (PROGRAM_ADDR)
 add hl, de
 ROM_CALL(D_ZT_STR)
SWt:
 call GET_KEY
 or a
 jr z, SWt

 ld hl, Nouveau
 CALL_(Load)
 ld de, $000D
 push de
Menu:
 push bc
 ROM_CALL(CLEARLCD)
 ld bc, 1
 ld ($800C), bc
 ld hl, Menu1
 ld de, (PROGRAM_ADDR)
 add hl, de
 ROM_CALL(D_ZT_STR)
 inc c
 ld ($800C), bc
 ROM_CALL(D_ZT_STR)
 inc c
 ld ($800C), bc
 ROM_CALL(D_ZT_STR)
 inc c
 ld ($800C), bc
 ROM_CALL(D_ZT_STR)
 inc c
 ld ($800C), bc
 ROM_CALL(D_ZT_STR)
 pop bc
MWt: 
 call GET_KEY
 cp K_EXIT
 jr z, Play
 cp K_F5
 JUMP_Z(Exit)
 cp K_F4
 jr z, New
 cp K_F2
 CALL_Z(Save)
 cp K_F3
 jr z, LoadS
 cp K_F1
 jr z, Play
 jr MWt
New:
 ld hl, Nouveau
 CALL_(Load)
 jr Play
LoadS:
 ld hl, Sauvegarde
 CALL_(Load)
Play:
 CALL_(AffChM)
MainLp: 
 pop de
 inc d
 push de
 push bc
 CALL_(PtChSpr)
 ld c, $17
Wtk1: 
 ld b, $FF
WtK: 
 call GET_KEY
 or a
 jr z, wk1
 ld b, 1
 ld c, 1
wk1:
 djnz WtK
 dec c
 jr nz, WtK1
 pop bc
 or a
 jr z, MainLp
 pop de
 push af
 ld a, 1
 and d
 CALL_NZ(PtChSpr)
 ld d, 0
 pop af
 push de
 cp K_F2
 CALL_Z(Save)
 cp K_EXIT
 jr z, Exit
 cp K_SECOND
 jr z, Second
 cp K_UP
 jr z, Up
 cp K_DOWN
 jr z, Down
 cp K_LEFT
 jr z, Left
 cp K_RIGHT
 jr z, Right
 cp K_MORE
 JUMP_Z(Menu)
 jr MainLp 

Exit:
 pop de
 ROM_CALL(CLEARLCD)
 ret

Up:
 ld a, 7
 and c
 ld c, a
 inc c
 jr MainLp

Down:
 dec c
 jr nz, MainLp
 ld c, 8
 jr MainLp 

Left:
 dec b
 jr nz, MainLp
 ld b, 8
 jr MainLp 

Right:
 ld a, 7
 and b
 ld b, a
 inc b
 jr MainLp

Second:
 ld a, (Sel)
 or a
 jr nz, SSel 
SNSel:
 CALL_(Ch)
 ld e, a
 or a
 JUMP_Z(MainLp)
 ld a, (Plr)
 or a
 jr z, Snsb
Snsn:
 ld a, 6
 cp e
 JUMP_NC(MainLp)
 jr Snso
Snsb:
 ld a, 6
 cp e
 JUMP_C(MainLp)
Snso:
 ld a, b
 ld (PxO), a
 ld a, c
 ld (PyO), a
 ld a, 1
 ld (Sel), a
 push bc
 ld b, 10
 ld c, 5
 ld a, (Pic)
 cp $0F
 jr z, Sns1
 ld d, e
 ld e, a
 CALL_(PtChSpr)
 ld e, d
Sns1: 
 ld a, e
 ld (Pic), a
 CALL_(PtChSpr)
 pop bc
 JUMP_(MainLp)

SSel:
 CALL_(Ch)
 ld e, a
 or a
 jr z, Sso
 ld a, (PxO)
 cp b
 jr nz, Ss1
 ld a, (PyO)
 cp c
 jr nz, SS1
 push bc
 ld b, 10
 ld c, 5
 CALL_(PtChSpr)
 pop bc
 xor a
 ld (Sel), a
 ld a, $0F
 ld (Pic), a
 JUMP_(MainLp)
Ss1: 
 ld a, (Plr)
 or a
 jr z, Ssb
Ssn:
 ld a, 6
 cp e
 JUMP_C(MainLp)
 jr Sso
Ssb:
 ld a, 6
 cp e
 JUMP_NC(MainLp)
Sso:
 ld a, b
 ld (PX), a
 ld a, c
 ld (PY), a
 push bc
 xor a
 ld (MOk), a
 ld a, (Plr)
 ld b, a
 sla b
 ld a, b
 sla b
 add a, b
 ld b, a
 ld a, (Pic)
 sub b
 ld (Ptp), a
 cp 1
 CALL_Z(Tour)
 ld a, (Ptp)
 cp 2
 CALL_Z(Cavalier)
 ld a, (Ptp)
 cp 3
 CALL_Z(Fou)
 ld a, (Ptp)
 cp 4
 CALL_Z(Dame)
 ld a, (Ptp)
 cp 5
 CALL_Z(Roi)
 ld a, (Ptp)
 cp 6
 CALL_Z(Pion)
 pop bc
 ld a, (MOk)
 or a
 JUMP_Z(MainLp) 
 CALL_(Ch)
 ld e, a
 ld d, e
 ld a, (Pic)
 ld (hl), a
 ld a, e
 or a
 CALL_NZ(PtChSpr)
 ld a, (Pic)
 ld e, a
 CALL_(PtChSpr)
 ld e, 0
 ld a, b
 add a, c
 and 1
 or d
 CALL_Z(PtChSpr)
 push bc
 ld a, (PxO)
 ld b, a
 ld a, (PyO)
 ld c, a
 ld a, (Pic)
 ld e, a
 CALL_(PtChSpr)
 ld e, 0
 ld a, b
 add a, c
 and 1
 CALL_Z(PtChSpr)
 CALL_(Ch)
 ld (hl), 0
 pop bc
 ld a, (Plr)
 inc a
 and 1
 ld (Plr), a
 xor a
 ld (Sel), a
 ld hl, $0366
 ld ($8333), hl
 ld de, (PROGRAM_ADDR)
 ld a ,(Plr)
 or a
 jr nz, an
ab:
 ld hl, Blancs
 jr ao
an:
 ld hl, Noirs
ao:
 add hl, de
 ROM_CALL(D_ZM_STR)
 ld a, (MOk)
 cp 4
 JUMP_Z(spd)
 dec a
 JUMP_Z(MainLp)
 push bc
 cp 2  
 jr z, sgd
spt:                ; low castle
 ld b, 8
 ld a, (Plr)
 or a
 jr nz, spb         ; (Plr) has already been changed !!!
spn:                ; low castle black
 ld e, 7
 CALL_(PtChSpr)
 CALL_(Ch)
 xor a
 ld (hl), a
 ld e, 0
 CALL_(PtChSpr)
 ld b, 6
 CALL_(PtChSpr)
 CALL_(Ch)
 ld a ,7
 ld (hl), a
 ld e, 7
 CALL_(PtChSpr)
 pop bc
 JUMP_(MainLp)
spb:                ; low castle white
 ld e, 1
 CALL_(PtChSpr)
 CALL_(Ch)
 xor a
 ld (hl), a
 ld b, 6
 CALL_(PtChSpr)
 CALL_(Ch)
 ld a, 1
 ld (hl), a
 pop bc
 JUMP_(MainLp)
sgd:                ; high castle
 ld b, 1
 ld a, (Plr)
 or a
 jr nz, sgb
sgn:                ; high castle black
 ld e, 7
 CALL_(PtChSpr)
 CALL_(Ch)
 xor a
 ld (hl), a
 ld b, 4
 ld e, 0
 CALL_(PtChSpr)
 ld e, 7
 CALL_(PtChSpr)
 CALL_(Ch)
 ld a, 7
 ld (hl), a
 pop bc
 JUMP_(MainLp)
sgb:                ; high castle white
 ld e, 1
 CALL_(PtChSpr)
 ld e, 0
 CALL_(PtChSpr)
 CALL_(Ch)
 xor a
 ld (hl), a
 inc e
 ld b, 4
 CALL_(PtChSpr)
 CALL_(Ch)
 ld a, 1
 ld (hl), a
 pop bc
 JUMP_(MainLp)
spd:                ; pawn changing to queen
 ld a, (Pic)
 ld e, a
 CALL_(PtChSpr)
 dec e
 dec e
 CALL_(PtChSpr)
 CALL_(Ch)
 ld a, e
 ld (hl), a
 JUMP_(MainLp)
 
Save:
 ld hl, Sauvegarde
 ld de, (PROGRAM_ADDR)
 add hl, de
 push bc
 ld de, ChM
 ld b, $20
slp: 
 ld a, (de)
 add a, a
 add a, a
 add a, a
 add a, a
 ld c, a
 inc de
 ld a, (de)
 add a, c
 ld (hl), a
 inc hl
 inc de
 djnz slp
 ld de, Rk
 ld a, (de)
 add a, a
 ld c, a
 inc de
 ld a, (de)
 add a, c
 add a, a
 ld c, a
 inc de
 ld a, (de)
 add a, c
 add a ,a
 ld c, a
 inc de
 ld a, (de)
 add a, c
 add a, a
 add a, a
 add a, a
 add a, a
 ld c , a
 ld a, (Pic)
 add a, c
 ld (hl), a
 inc hl
 ld a, (Plr)
 add a, a
 add a, a
 add a, a
 ld c, a
 ld a, (PxO)
 dec a
 add a, c
 add a, a
 ld c, a
 ld a, (Sel) 
 add a, c
 add a, a
 add a ,a
 add a, a
 ld c, a
 ld a, (PyO)
 dec a
 add a, c
 ld (hl), a
 inc hl
 ld a, (PX)
 add a, a
 add a, a
 add a, a
 add a, a
 ld c, a
 ld a, (PY)
 add a, c
 ld (hl), a
 inc hl
 pop bc
 ld a, b
 add a, a
 add a, a
 add a, a
 add a, a
 add a, c
 ld (hl), a
 xor a
 ret

Load: 
 ld de, (PROGRAM_ADDR)
 add hl, de
 ld b, $20
 ld de, ChM
ldlp: 
 ld a, (hl)
 ld c, a
 srl a
 srl a
 srl a
 srl a
 ld (de), a
 inc de
 ld a, c
 and $0F
 ld (de), a
 inc hl
 inc de
 djnz ldlp
 ld a, (hl)
 ld b, a
 and $0F
 ld (Pic), a
 ld a, b
 ld de, Pic
 dec de
 srl a
 srl a
 srl a
 srl a
 ld c, 1
 ld b, a
 and c
 ld (de), a
 dec de
 ld a, b
 srl a
 ld b, a
 and c
 ld (de), a
 dec de
 ld a, b
 srl a
 ld b, a
 and c
 ld (de), a
 dec de
 ld a, b
 srl a
 and c
 ld (de), a
 inc hl
 ld a, (hl)
 ld b, a
 bit 7, a
 jr z, lp0
lp1:
 ld a, 1
 jr lpo
lp0:
 xor a 
lpo: 
 ld (Plr), a
 ld a, b
 bit 3, a
 jr z, ls0
ls1:
 ld a, 1
 jr lso
ls0:
 xor a 
lso: 
 ld (Sel), a
 ld a, b
 and 7
 inc a
 ld (PyO), a
 ld a, b
 srl a
 srl a
 srl a
 srl a
 and 7
 inc a
 ld (PxO), a
 inc hl
 ld a, (hl)
 ld b, a
 ld c, $0F
 and c
 ld (PY), a
 ld a, b
 srl a
 srl a
 srl a
 srl a
 ld (PX), a
 inc hl
 ld a, (hl)
 ld b, a
 and c
 ld c, a
 srl b
 srl b
 srl b
 srl b
 ret

Grille:             ; display the grid
 ROM_CALL(CLEARLCD)
 ld hl, $FC34
 ld b, $39
 ld de, 7
CkBd1a:
 ld c, b
 ld b, 9
CkBd2a:
 ld (hl), %10000000
 inc hl
 djnz CkBd2a
 ld b, c
 add hl, de
 djnz CkBd1a
 ld hl, $FC34
 ld b, 9
 ld de, $68
CkBd1b:
 ld c, b
 ld b, 8
CkBd2b:
 ld (hl), %11111111
 inc hl
 djnz CkBd2b
 ld b, c
 add hl, de
 djnz CkBd1b
 ret

AffChM:             ; display the chessboard.
 push bc
 push de
 CALL_(Grille)
 ld bc, $0808
acmlp: 
 CALL_(Ch)
 ld e, a
 or a
 jr z, vide
 CALL_(PtChSpr)
 djnz acmlp
 jr acm1
vide:
 ld a, b
 add a, c
 and 1
 CALL_Z(PtChSpr)
 djnz acmlp
acm1:
 ld b, 8
 dec c
 jr nz, acmlp
 ld hl, $0366
 ld ($8333), hl
 ld de, (PROGRAM_ADDR)
 ld a ,(Plr)
 or a
 jr nz, aan
aab:
 ld hl, Blancs
 jr aao
aan:
 ld hl, Noirs
aao:
 add hl, de
 ROM_CALL(D_ZM_STR)
 ld a, (Pic)
 cp $0F
 jr z, ae
 ld bc, $0A05
 ld e, a
 CALL_(PtChSpr)
ae: 
 pop de
 pop bc
 ret

PtChSpr:            ; display the #e sprite at (b, c) 
 ld hl, $FC43       
 push bc            
 push de            
 ld a, 8            ; drawing address is
 sub c              ; hl = $FC43 + $70 * (8-c) + b
 ld c, a
 xor a              
 sub c              
 sla c
 sla c
 sla c
 add a, c
 ld c, a
 ld a, b
 ld b, 0
 sla c
 rl b
 sla c
 rl b
 sla c
 rl b
 sla c
 rl b
 add a, c
 jr nc, pts1
 inc b
pts1: 
 ld c, a
 add hl, bc
 push hl
 ld a, e
 ld hl, (PROGRAM_ADDR)
 ld de, CaseNoire
 add hl, de
 ld e, a 
 add a, a
 sla e
 sla e
 add a, e
 ld d, 0
 ld e, a
 add hl, de
 ex de, hl
 pop hl
 ld b, 6
ptslp:
 ld a, (de)
 ld c, a
 ld a, (hl)
 xor c
 ld (hl), a
 ld a, b
 inc de
 ld bc, $10
 add hl, bc
 ld b, a
 djnz ptslp
 pop de
 pop bc
 ret

Abs:                ; |a-b| -> a
 sub b
 ret nc
 neg
 ret

Ch:                 ; ChM(b,c) -> a
 push bc            ; addr(ChM(b,c)) -> hl
 ld hl, ChM
 dec b
 ld a, b
 dec c
 sla c
 sla c
 sla c
 add a, c
 ld b, 0
 ld c, a
 add hl, bc
 ld a, (hl)
 pop bc
 ret

Tour:               ; 1 -> MOk if the Move is Ok
 ld a, (PX)
 ld d, a
 ld a, (PxO)
 ld b, a
 cp d               ; if (PxO)=(PX)
 jr z, tour2        ; then goto tour2
 ld a, (PyO)
 ld c, a
 ld a, (PY)
 cp c               ; else we should have (PyO)=(PY)
 ret nz
 CALL_(Ch)          ; load hl
 ld a, d
 CALL_(Abs)
 dec a
 jr z, trlp1
 ld b, a            ; iteration number 
 ld a, (PxO)
 cp d               ; if (PxO)>(PX)
 jr c, tour1        ; then
 ld de, $FFFF       ; -1 (backward)
 jr trlp
tour1:              ; else
 ld de, 1           ; +1 (forward)
 jr trlp
tour2:
 ld a, (PyO)
 ld c, a
 CALL_(Ch)          ; load hl
 ld a, (PY)
 ld d, a
 ld b, c
 CALL_(Abs)
 dec a
 jr z, trlp1
 ld b, a            ; iteration number
 ld a, d
 cp c               ; if (PyO)>(PY)
 jr nc, tour3       ; then
 ld de, $FFF8       ; -8 (backward)
 jr trlp
tour3:              ; else
 ld de, 8           ; +8 (...)
trlp:               ; to know if there are things between dest and origin 
 add hl, de
 ld a, (hl)
 or a
 ret nz             ; ret if not empty
 djnz trlp
trlp1:
 inc a
 ld (MOk), a        ; the move is accepted
 
 ld a, (Plr)        ; prevent from a castle on this side for this player
 ld b, a
 sla a
 add a, b
 sla b
 add a, b
 ld b, a
 inc b
 ld a, (PyO)
 cp b               ; what's the row :
 ret nz             ; 1=7*0+1 for whites and 8=7*1+1 for ...
 ld a, (PxO)
 cp 8               ; low
 jr z, trrq
 cp 1               ; or high
 ret nz
 ld a, (Plr)
 add a, a
 ld hl, Rk
 ld e, a
 xor a
 ld d, a
 add hl, de
 ld (hl), a
 ret
trrq:
 ld a, (Plr)
 add a, a
 inc a
 ld hl, Rk
 ld e, a
 xor a
 ld d, a
 add hl, de
 ld (hl), a
 ret
 
Fou:
 ld a, (PX)
 ld b, a
 ld a, (PxO)
 ld d, a
 CALL_(Abs)
 ld c, a
 ld a, (PY)
 ld b, a
 ld a, (PyO)
 ld e, a
 CALL_(Abs)
 cp c               ; bishop moves diagonally
 ret nz
 dec a              ; adjacents squares
 jr z, flp1         ; then Ok
 ld b, d
 ld c, e
 ld d, a
 CALL_(Ch)          ; load hl
 ld c, b
 ld b, d            ; iteration number
 ld a, (PY)
 cp e               ; if (PY)>(PyO)
 jr nc, fou1        ; then fou1, else
 ld de, $FFF8       ; -8
 jr fou2
fou1:
 ld de, 8           ; +8
fou2:
 ld a, (PX)
 cp c               ; if (PX)>(PxO)
 jr nc, fou3
 dec e              ; -9 or +7
 jr flp
fou3:
 inc e              ; -7 or +9
flp: 
 add hl, de
 ld a, (hl)
 or a
 ret nz             ; empty squares ? 
 djnz flp
flp1:
 inc a
 ld (MOk), a        ; Ok
 ret

Dame:
 CALL_(Tour)
 CALL_(Fou)
 ret

Cavalier:           ; 1 -> MOk if correct move
 ld a, (PxO)        
 ld b, a            
 ld a, (PX)         
 CALL_(Abs)
 ld c, a
 ld a, (PyO)
 ld b, a
 ld a, (PY)
 CALL_(Abs)
 cp 2
 jr z, cav1
 cp 1
 ret nz
 ld a, c
 cp 2
 ret nz
 dec a
 ld (MOk), a
 ret
cav1:
 ld a, c
 cp 1
 ret nz
 ld (MOk), a
 ret

Roi:                ; (MOk) can be after that :
 ld a, (PY)         ;       0 if not Ok
 ld b, a            ;       1 if Ok
 ld a, (PyO)        ;       2 if low castle
 CALL_(Abs)         ;       3 if high castle 
 cp 2
 ret nc
 ld a, (PX)
 ld b, a
 ld a, (PxO)
 CALL_(Abs)
 cp 2
 JUMP_C(ro)
 ld a, (PY)
 ld c, a
 ld a, (Plr)
 ld b, a
 neg
 sla b
 sla b
 sla b
 add a, b
 inc a
 cp c
 ret nz
 ld a, (PX)
 ld b, a
 cp 7
 jr z, rr1
 cp 3 
 ret nz
 ld d, 0
 ld a, (Plr)
 add a, a
 ld e, a
 ld hl, Rk
 add hl, de
 ld a, (hl)
 or a
 ret z
 dec b
 dec b
 CALL_(Ch)
 ld e, a
 ld a, (Plr)
 ld d, a
 add a, d
 sla d
 sla d
 add a, d
 inc a
 cp e
 ret nz
 inc hl
 ld a, (hl)
 or a
 ret nz
 inc hl
 ld a, (hl)
 or a
 ret nz
 inc hl
 ld a, (hl)
 or a
 ret nz
 ld a, 2
 ld (MOk), a
 jr ro
rr1: 
 ld d, 0
 ld a, (Plr)
 add a, a
 inc a
 ld e, a
 ld hl, Rk
 add hl, de
 ld a, (hl)
 or a
 ret z
 dec b
 CALL_(Ch)
 or a
 ret nz
 inc hl
 ld a, (hl)
 or a
 ret nz
 inc hl
 ld a, (hl)
 ld e, a
 ld a, (Plr)
 ld d, a
 add a, d
 sla d
 sla d
 add a, d
 inc a
 cp e
 ret nz
 ld a, 1
 ld (MOk), a
ro:
 ld a, (MOk)
 inc a
 ld (MOk), a
 ld a, (Plr)
 ld d, 0
 add a, a
 ld e, a
 ld hl, Rk
 add hl, de
 ld (hl), 0
 inc hl
 ld (hl), 0
 ret

Pion:               ; in MOk : 1 if Ok
 ld a, (PX)         ;          4 if changing to queen
 ld b, a
 ld a, (PY)
 ld c, a
 CALL_(Ch)
 or a
 jr nz, Pp
 ld a, (PxO)
 cp b
 ret nz
 ld a, (PyO)
 sub c
 ld b, a
 ld a, (Plr)
 add a, a
 dec a
 cp b
 jr z, Po
 add a, a
 cp b
 ret nz
 ld a, (Plr)
 add a, 4
 cp c
 ret nz
 jr po
Pp:
 ld a, (PX)
 ld b, a
 ld a, (Pxo)
 CALL_(Abs)
 dec a
 ret nz
 ld a, (PyO)
 sub c
 ld b, a
 ld a, (Plr)
 add a, a
 dec a
 cp b
 ret nz
Po: 
 ld a, 1
 ld (MOk), a
 ld a, (Plr)
 dec a
 ld b, a
 neg 
 add a, a
 add a, a
 add a, a
 add a, b
 inc a
 ld b, a
 ld a, (PY)
 cp b
 ret nz
 ld a, 4
 ld (MOk), a
 ret

;-----------------------------------------------------
; Data
;-----------------------------------------------------
Nouveau:            ; for new game
 .db $12, $34, $53, $21 ; chessboard
 .db $66, $66, $66, $66
 .db $00, $00, $00, $00
 .db $00, $00, $00, $00
 .db $00, $00, $00, $00
 .db $00, $00, $00, $00
 .db $CC, $CC, $CC, $CC 
 .db $78, $9A, $B9, $87
 .db %11111111      ; b7->b4 : Rk ; b3->b0 : Pic
 .db %00000000      ; b7 : Plr ; b6->b4 : PxO-1 ; b3 : Sel ; b2-> b0 : PyO-1
 .db %00000000      ; b7->b4 : PX ; b3->b0 : PY
 .db %01010100      ; b7->b4 : b ; b3->b0 : c

Sauvegarde:
 .db $00, $00, $00, $00
 .db $00, $00, $00, $00
 .db $00, $00, $00, $00
 .db $00, $00, $00, $00
 .db $00, $00, $00, $00
 .db $00, $00, $00, $00
 .db $00, $00, $00, $00
 .db $00, $00, $00, $00
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000

;-----------------------------------------------------
; Messages
;-----------------------------------------------------
Blancs:
 .db "white", 0
Noirs:
 .db "black", 0

Menu1:
 .db "[F1] Play", 0
Menu2:
 .db "[F2] Save game", 0
Menu3:
 .db "[F3] Load game", 0 
Menu4: 
 .db "[F4] New game", 0
Menu5:  
 .db "[F5] Quit", 0

MyScr:   
 .db "        ZShess       "
 .db "       --------      "
 .db "     version 1.0e    "
 .db "         by          "
 .db "    Francis Colas    "
 .db "  fcolas@yahoo.com", 0 

;-----------------------------------------------------
; Sprites : * b7 never set (7 cols)
;           * 6 rows
;-----------------------------------------------------
CaseNoire:          
 .db %01010101
 .db %00101010
 .db %01010101
 .db %00101010
 .db %01010101
 .db %00101010
TourB:
 .db %00101010
 .db %00111110
 .db %00010100
 .db %00010100
 .db %00010100
 .db %00111110
CavalierB:
 .db %00001100
 .db %00010111
 .db %00101001
 .db %01010110
 .db %00110100
 .db %00111110
FouB:
 .db %00001000
 .db %00011100
 .db %00101010
 .db %00100010
 .db %00011100
 .db %01110111
DameB:
 .db %00001000
 .db %00011100
 .db %01110111
 .db %01010101
 .db %00110110
 .db %00111110
RoiB:
 .db %00011100
 .db %00110110
 .db %00100010
 .db %00110110
 .db %00011100
 .db %00111110
PionB:
 .db %00001000
 .db %00010100
 .db %00001000
 .db %00010100
 .db %00010100
 .db %00111110
TourN:
 .db %00101010
 .db %00111110
 .db %00011100
 .db %00011100
 .db %00011100
 .db %00111110
CavalierN:
 .db %00001100
 .db %00010111
 .db %00111111
 .db %01111110
 .db %00111100
 .db %00111110
FouN:
 .db %00001000
 .db %00011100
 .db %00111110
 .db %00111110
 .db %00011100
 .db %01110111
DameN:
 .db %00001000
 .db %00011100
 .db %01111111
 .db %01011101
 .db %00111110
 .db %00111110
RoiN:
 .db %00011100
 .db %00111110
 .db %00111110
 .db %00111110
 .db %00011100
 .db %00111110
PionN:
 .db %00001000
 .db %00011100
 .db %00001000
 .db %00011100
 .db %00011100
 .db %00111110
Curseur:
 .db %01111111
 .db %01111111
 .db %01111111
 .db %01111111
 .db %01111111
 .db %01111111
;-----------------------------------------------------
; That's all folks.
;-----------------------------------------------------
.end
